package sample.websocket;

import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.poscoict.glueframework.context.GlueStaticContext;
import com.poscoict.glueframework.websocket.GlueAbstractWebSocketHandler;
import com.poscoict.glueframework.websocket.GlueWebSocketDirectSender;

/**
 * DirectSender를  applicationContext.xml 과  dispatcher-socket-servlet.xml 에서 정의 하지 않고
 * 소스 코드 안에서 생성하여 applicationContext.xml 에서 정의된 handler를 설정하는 샘플 코드 
 * */

public class SampleDirectSender implements GlueWebSocketDirectSender {

	public SampleDirectSender() {
	}

	GlueAbstractWebSocketHandler handler;
	private Logger logger = LoggerFactory
			.getLogger(SampleDirectSender.class);
	
	private Map<String, String> propertiesMap;


	@Override
	public void setWebSocketHandler(GlueAbstractWebSocketHandler handler) {
		this.handler = handler;
	}	
	
	@Override
	public void receiveDirectMessage(String msg) {
		logger.info("[RCV TXT from handler]" + msg);
	}
	

	@Override
	public void receiveDirectMessage(byte[] msg) {
	}

    public void setPropertiesMap( Map<String, String> propertiesMap )
    {
    	this.propertiesMap = propertiesMap;
    	
    	String handlerId =  this.propertiesMap.get("handlerId");
    	GlueAbstractWebSocketHandler handler = GlueStaticContext.getBeanFactory().getBeanObject( handlerId , GlueAbstractWebSocketHandler.class );
    	this.setWebSocketHandler(handler);
    
    	//handler로
    	handler.registerDirectSender("", this);
    }

	@Override
	public void receiveCommand(String cmd) {
	}

	@Override
	public GlueAbstractWebSocketHandler getHandler() {
		return this.handler;
	}

}
