package sample.websocket;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.InitializingBean;

import sample.publisher.AutoPublisher;

import com.poscoict.glueframework.websocket.GlueAbstractWebSocketHandler;

/**
 * DirectSender를  applicationContext.xml 과  dispatcher-socket-servlet.xml 에서 정의 하지 않고
 * 소스 코드 안에서 생성하여 사용하는 샘플 코드  
 * */
public class SampleWebSocketHandler extends GlueAbstractWebSocketHandler implements
		InitializingBean {
	
	private static Logger logger = LoggerFactory.getLogger(SampleWebSocketHandler.class);
	
	public SampleWebSocketHandler() {
		super();
		this.logger.info("create SocketHandler instance!");
	}

	@Override
	public void afterPropertiesSet() throws Exception {
		/***** Method 1 *********/
		
		logger.info("SampleWebSocketHandler CREATED *******************");
		AutoPublisher ap = new AutoPublisher();
		ap.setWebSocketHandler(this);
		new Thread( ap ).start();
	}
}
